{ This is the input data: N, M;  weight[1..N];  v1, v2, dist_v1_v2 :
 12 16
 7 9 5 1 1 2 4 2 5 3 8 8
 1 2  17
 1 4  4
 1 9  3
 1 12  9
 2 6  20
 2 4  1
 3 6  4
 3 7  9
 4 6  1
 4 7  11
 4 8  3
 5 9  8
 7 8  5
 8 12  2
 9 11  6
 10 12  5
                        --------------------
                         4 - 
                        --------------------

                .  
        ,  
     .        
        .  
     -   .    4- -
       .  -  4- , 
    6-     .     
     , ..   .      
  N  M -     , N  -     M
       , , .
      :          
 .     .  G[1..N,1..N]  -
   , ..    (v1,v2,len) G[v1,v2]=len  G[i,i]=0  -
  G[i,j]=      i, j.   -
 ,    ,       -
     ,     ,     
     .        -
    v1  v2     t,     v1  v2  t
  -     -   v1  v2  :
      G[v1,t]+W[t]+G[t,v2] > G[v1,v2].
            :
      for t = 1 ... N
        for v1 = 1 ... N
          for v2 = 1 ... N
            if G[v1,v2] = min ( G[v1,v2],  G[v1,t]+W[t]+G[t,v2] )
        N*N*N.
           -       
 .           -
 :
      MinR = 
      for v1 = 1 ... N
        for v2 = 1 ... N
          for v3 = 1 ... N
            for v4 = 1 ... N
              MinR = min ( MinR,
                G[v1,v2]+G[v1,v3]+G[v1,v4]+G[v2,v3]+G[v2,v4]+G[v3,v4] )
   ,       (   N*N*N*N).
      .      -
  - ,          
   .         ,  -
            
   .      ,     , --
      .         
    ,         -
   .   ,     -.  
        -     
          ,  -
      , ..    -
   ,    ,    .
         3 ,      , 
    - GREEDY .      : 
    3- ,   -     -
       -  .   -
    ,   .    -,   
 N     N!*(N-4)!/4!.     
     .   N ,    
     N > 100       N <= 100.  
      ,       -
 .     .         
 ,  ,     3    ,    
  .      ,   -
   -.       ,  -
  - 100,          .
  ,     -    -
    ( 3- - ).    
      .   .  10-  -
   -   ( N-      
  10-,     10 ).   
  10-  -        .
    (-    -   N) 
    ,   .       -
 .
                . 
   , ..  - ,    , -
        ,    3- --
   (   -)        
  .       ,  -
     ,      
  ,     ,      -
       .    
     ,   ,   -
    ,           -
    ( -     ,   -
 ).      .       
   100  150,    700.       
   ,    2 ,   
    .     ,    
   ,     .  
    -.       -
 .   2    - ,     -
   -    2-   4 .   3
    - ,     ,  
  3   4, .. -      -
       3 .      
      100  150,     , -
    v1  v2  - G[v1,v2] + 5*100,   
      6 ,      -  100, 
     G[v1,v2].     v1, v2  v3 -
   -    G[v1,v2]+G[v1,v3]+G[v2,v3]+3*100.  -
    -  -        -
  -.         
   -  ,  -   . -
       ,    --
        .      
  T[1..6]   6- -     .-
      ,       
  .      G[v1,v2]+T[1]+T[2]+T[3]+T[4]+T[5],   3 -
   G[v1,v2]+G[v1,v3]+G[v2,v3]+T[1]+T[2]+T[3].   T[1]..T[5]
  T[1]..T[3]            
   .      
       .

                                                                  22.03.2000
                                                                
                                                          (  )
}

{$R-,Q-,S-}

CONST InFileName  = '4VURHA.PAS';
      OutFileName = '';
      MaxN        = 175;
      EndLess     = 30000;

TYPE TGraph = array[1..MaxN,1..MaxN] of word;

VAR G: TGraph;                  { The distance matrix of the graph }
    N,M: integer;
    W: array[1..MaxN] of byte;

    BestSum: longint;


Procedure ReadData; { Read the input data - N, M, W[1..N], G[1..N,1..N] }
Var F: Text;
    v1,v2,r: integer;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N,M);
  for v1:=1 to N do
    for v2:=1 to N do
      if v1=v2 then G[v1,v2]:=0
      else G[v1,v2]:=EndLess;
  for N:= 1 to N do
    Read(F,W[N]);
  for M:= 1 to M do
    begin
      ReadLn(F,v1,v2,r);
      G[v1,v2]:=r; G[v2,v1]:=r;
    end;
  Close(F);
End;


Procedure Floyd; { Apply Floyd's algorithm to find distances in G[][] }
Var t,v1,v2: integer;
Begin
  for t:= 1 to N do
    for v1:=1 to N do
      for v2:= 1 to N do
        if G[v1,t]+W[t]+G[t,v2] < G[v1,v2] then
           G[v1,v2] := G[v1,t]+W[t]+G[t,v2];
End;


Procedure Approximate4Nearest; { Greedy approximation of BestSum }
Type TR = record v,d:word; end;
Var R: array[1..MaxN] of TR;
    v,i,v1,v2,v3,v4: integer;
    Sum: longint;

  Procedure SortR;
  Var i,j,Min: integer;
      Tmp: TR;
  Begin
    for i:= 1 to N-1 do
      begin
        Min:=i;
        for j:= i+1 to N do
          if R[j].d < R[Min].d then
            Min:=j;
        Tmp:=R[i]; R[i]:=R[Min]; R[Min]:=Tmp;
      end;
  End;

Begin
  BestSum:=MaxLongInt;
  for v:= 1 to N do
    begin
      for i:=1 to N do
        begin R[i].v:=i; R[i].d:=G[v,i]; end;
      SortR;
      v1:=v; v2:=R[2].v; v3:=R[3].v; v4:=R[4].v;
      Sum:=G[v1,v2]+G[v1,v3]+G[v1,v4]+G[v2,v3]+G[v2,v4]+G[v3,v4];
      if Sum < BestSum then
        BestSum:=Sum;
    end;
End;


Procedure Find4Nearest; { The fast algorithm with the bounds }
Var T: array[1..MaxN] of integer;

  Procedure FindMin6Dist;
  Var D: ^TGraph;
      i,v1,v2,bestv1,bestv2: integer;
  Begin
    New(D); D^:=G;
    for i:= 1 to 6 do
      begin
        bestv1:=1; bestv2:=2;
        for v1:= 1 to N do
          for v2:= v1+1 to N do
            if D^[v1,v2] < D^[bestv1,bestv2] then
              begin bestv1:=v1; bestv2:=v2; end;
        T[i]:=D^[bestv1,bestv2];
	D^[bestv1,bestv2]:=MaxInt;
      end;
    for i:= 2 to 6 do
      T[i]:=T[i]+T[i-1];
    Dispose(D);
  End;

Var Sum1,Sum2,Sum3,Sum4,T3,T5: longint;
    v1,v2,v3,v4: integer;
Begin
  FindMin6Dist; T5:=T[5]; T3:=T[3];
  for v1:= 1 to N do
    begin
      Sum1:=0;
      for v2:= v1+1 to N do
        begin
          Sum2:=Sum1+G[v1,v2];
	  if Sum2 + T5 < BestSum then
            for v3:= v2+1 to N do
              begin
                Sum3:=Sum2+G[v1,v3]+G[v2,v3];
                if Sum3 + T3 < BestSum then
                   for v4:= v3+1 to N do
                     begin
                       Sum4:=Sum3+G[v1,v4]+G[v2,v4]+G[v3,v4];
                       if Sum4 < BestSum then
                         BestSum:=Sum4;
                     end;
              end;
        end;
    end;
End;


Procedure PrintSolution; { Print the found solution - BestSum }
Var OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,BestSum);
  Close(OutF);
End;



BEGIN
  ReadData;
  Floyd;
  Approximate4Nearest;
  Find4Nearest;
  PrintSolution;
END.
