{ This is the input data:  N;  x1 y1;  x2 y2;  ...;  xN yN.
 8
 14 16
 13 18
 11 18
 3 14
 1 8
 4 2
 11 4
 14 6
                           
                         --------------------------

          2  1998.     
         Computer . 5. :  ,  
       ----------------------------------------------------------------

      :   N   ,   -
  .       ,   
 .         ,  
     ,    .    
   ,        -
         ,  -
    .

      :      .   
 ,       ,  ,    -
      .    ,    -
           .
   F(b,e)        -
     b     e.   ,  F(b,e) 
       :
    F(b,b+1) =  0
    F(b,e)   =  MIN (  f(b,i) + f(i,e) + d(b,i) + d(i,e)  )   i = b+1..e-1
   d(x,y)     (x,y)    
 d(x,x+1)=0,    (x,x+1)       
   .       , 
      ,       -
 ,        ,   -
      .      -
     ,       
       b-e    b-i-e 
   ,        
       ,   
  .        F(1,N).     -
          F(),    ,
      F(b,e)      ,   -
 ,       .    -
        ,    -
 ,      (b,b+1,....,e)  ,
    .       
        
      .    
     N*N*N.
}

CONST InFileName = 'CUTPOLYG.PAS';
      MaxN       = 150;
      Eps        = 0.01;
      NotCalculated = -1;


TYPE TF = array[1..MaxN] of
             record
	       Len: longint;
               Cut: integer;
             end;


VAR D: array[1..MaxN,1..MaxN] of integer;
    N: integer;
    F: array[1..MaxN] of ^TF;


Procedure ReadData; { Read the polygon and calculate d(1..N,1..N) }
  Function Distance(x1,y1,x2,y2: single): integer;
  Begin
    Distance:= round( SQRT(sqr(x1-x2)+sqr(y1-y2)) / Eps );
  End;
Var F: Text;
    P: array[1..MaxN] of
         record x,y:single; end;
    I,J: integer;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for I:= 1 to N do
    with P[I] do
      ReadLn(F,x,y);
  for I:= 1 to N do
    for J:= 1 to N do
      if abs(I-J) = 1 then D[I,J]:=0
      else D[I,J]:= Distance(P[I].x,P[I].y, P[J].x,P[J].y);
  Close(F);
End;


Procedure CalculateMinimalCut(b,e:integer); { Calculate F(b,e) }
Var i: integer;
    L: longint;
Begin
  if F[b]^[e].Len <> NotCalculated then Exit; {Already calculated}

  if b+1 = e then {F(b,b+1)=0}
    with F[b]^[e] do
      begin Len:=0; Cut:=0; Exit; end;

  {F(b,e)  =  MIN (  f(b,i) + f(i,e) + d(b,i) + d(i,e)  )  for i = b+1..e-1}
  F[b]^[e].Len:=MaxLongint;
  for i:= b+1 to e-1 do
    with F[b]^[e] do
      begin
        CalculateMinimalCut(b,i);
        CalculateMinimalCut(i,e);
        L:= F[b]^[i].Len + F[i]^[e].Len + D[b,i] + D[i,e];
        if L < Len then
          begin Len:= L; Cut:=i; end;
      end;
End;


Procedure PrintCut(b,e:integer);
Begin
  with f[b]^[e] do
    if Cut <> 0 then
      begin
        if b+1 < Cut then WriteLn(b,'-',Cut);
        if Cut+1 < e then WriteLn(Cut,'-',e);
        PrintCut(b,Cut);
        PrintCut(Cut,e);
      end;
End;


VAR i,j: integer;

BEGIN
  ReadData;

  for i:= 1 to N do
    begin
      new(F[i]);
      for j:= 1 to N do
        F[i]^[j].Len:=NotCalculated;
    end;
  CalculateMinimalCut(1,N);

  WriteLn;
  WriteLn('Minimal cut length: ',  F[1]^[N].Len);
  WriteLn('Cut the polygon along these diagonals:');
  PrintCut(1,N);
END.
