{ This is the input data:  N;  X1 Y1;  X2 Y2;  ...;  Xn Yn;
  11
 6  0
-6  3
 1  7
 2  0
 5 -3
 11 2
 5  7
 1  2
 6  3
 9  7
 4  6
                             
                            --------------

              N       
 .       ,   
             
        .    ,  -
     ,       .
       .

     :  ,       ,  
    ,     ,     
         .   -
             -
 .        .  
      ,   -     
 .        ,  
       .  
   (x1,y1)  (x2,y2)    :
    R = SQRT( (x1-x2) + (y1-y2) )
        .    
       ,        
   , ,      0  -
      .        
 (x1,y1), (x2,y2), (x3,y3).         -
  :
     = (x1-x2)*(y1+y2) + (x2-x3)*(y2+y3) + (x3-x1)*(y3+y1)
           . 
        ,     -. 
          :  -
  -  A      B,    
       AB.    AB    -
  .     C, ,      
  BC  ..       ABCD..., -
    .        X  
    AB,    ABX   .  -
              -
 ,    ,    ,  ,   -
      N*N*N  - .     -
   ,    -,    -
    N*logN  - ,    -.
         X  ,   
  X     Y .   ,  -
     -   -,   (N-)
  -   - .  ,    
     .     ,   
  ,   .    1
   (-  - ).     
    .        -
             
    .     ,    -
 ,   ,      ,  -
 ,            . -
           
            
           -
              -
  (N-,-  ) .      "-
 "   .       , 
          ,  , ..
        ,    .
       ""   .  -
  ,             
  (       ).    
              -
         .
}

{$M 16384,0,655360}
CONST MaxN = 500;
      InFileName  = 'GAR.PAS';
      OutFileName = '';


TYPE TPoint = record x,y:longint end;


VAR P: array[1..MaxN] of TPoint;
    N: integer;
    Ograda: array[1..MaxN] of integer;


Procedure ReadData; {    N  P[1..N] }
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    with P[N] do
      ReadLn(F,x,y);
  Close(F);
End;


Function Direction(p1,p2,p3:integer): longint;
Begin {    3-    p1, p2  p3 }
  Direction:=
      (P[p1].x-P[p2].x)*(P[p1].y+P[p2].y)
    + (P[p2].x-P[p3].x)*(P[p2].y+P[p3].y)
    + (P[p3].x-P[p1].x)*(P[p3].y+P[p1].y);
End;


Function R(p1,p2:integer): real;
Begin
  R:= SQRT( sqr(P[p1].x-P[p2].x) + sqr(P[p1].y-P[p2].y) );
End;


Procedure SortPointsByX; {     X      Y }
  Procedure Swap(var a,b:TPoint);
  Var Tmp: TPoint;
  Begin
    Tmp:=a; a:=b; B:=Tmp;
  End;
Var I,J: integer;
Begin
  for I:= 1 to N-1 do
    for J:= I+1 to N do
      if (P[J].x < P[I].x) OR
        ((P[J].x = P[I].x) and (P[J].y < P[I].y)) then
          Swap(P[J],P[I]);
End;


Procedure Solve; {         }

Var Count, I: integer;
    OutF: Text;
    Sum: real;
    Used: array[1..MaxN] of boolean;

  Procedure Add(P:integer); {     P   }
  Begin
    Inc(Count); Ograda[Count]:=P;
    Used[P]:=true;
  End;

  Function Last3: longint; {    3-      }
  Begin
    if Count < 3 then Last3:=-1
    else Last3:=Direction(Ograda[Count-2],Ograda[Count-1],Ograda[Count]);
  End;

Begin
  FillChar(Used,SizeOf(Used),false);
  Count:=0; Add(1);
  { Find the up part of the cover }
  repeat
    for I:= Ograda[Count]+1 to N do
      if not Used[I] then
        begin
          Add(I);
          while Last3 >= 0 do
            begin
              Used[Ograda[Count-1]]:=false;
              Ograda[Count-1]:=Ograda[Count];
				  Dec(Count);
            end;
        end;
  until Ograda[Count] = N;
  { Find the down part of the cover }
  Used[1]:=false; { Use vertice 1 again in the down part of the cover }
  repeat
    for I:= Ograda[Count]-1 downto 1 do
      if not Used[I] then
        begin
          Add(I);
          while Last3 >= 0 do
            begin
              Used[Ograda[Count-1]]:=false;
              Ograda[Count-1]:=Ograda[Count];
				  Dec(Count);
            end;
        end;
  until Ograda[Count] = 1;
  { Calculate the length of the found cover }
  Sum:=0;
  for I:= 1 to Count-1 do
    Sum:= Sum + R(Ograda[I],Ograda[I+1]);
  Assign(OutF,OutFileName); Rewrite(OutF);
  if Frac(Sum)=0 then
     WriteLn(OutF,trunc(Sum))
  else WriteLn(OutF,trunc(Sum+1));
  Close(OutF);
End;


BEGIN
  ReadData;
  SortPointsByX;
  Solve;
END.