{ This is the input data:  N;  S1 h1 m1;  S2 h2 m2;  ...;  S(N) h(N) m(N).
 5
 28 3 40
 4 4 60
 10 2 30
 16 2 50
 1 5 20

                                 
                                -----------

       N (N<=250) ,        
 ,   .         
     -   -   .  
       .       -
  ,        .

     :        ,  
     v1   v2     v2    -
    v1.       .    -
          NP-       
       ,    .
     (.      
   ).  -       -
  -,          ().   -
 ,    .   "  " 
            -
  .         
  ,       i (  ) 
  -   i,         -
        .    , 
      i       -
     i,    .    -
 ,       1   N   -
        i,   
    i   .   F(i)   i 
    F(i) = h   i    
    F(i) = Max( F(j)+h )   j   ,
        i, h    i
  ,      i  .    v  -
  ,    i      .
         
     :     ,   -
 ;            ;
    .       -
 ,    ,         
         ,   -
            .
           - -
    - ,   .
 :         -
  .
}

CONST MaxN = 250;
      InFileName  = 'TOW.PAS';
      OutFileName = '';


TYPE TCylinder = record S,h,m: integer; end;


VAR C: array[1..MaxN] of TCylinder;
    N: integer;
    Order: array[1..MaxN] of integer;


Procedure ReadData; { Read the input data - N, C[1..N] }
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    with C[N] do
      Read(F, S,h,m);
  Close(F);
End;


Function CanBePut(Up,Down:integer): boolean;
Begin { Return if the cylinder Up can be put over cylinder Down }
  CanBePut:= (C[Down].S > C[Up].S) and (C[Down].m > C[Up].m);
End;


Procedure TopSort; { Sort topologicaly the graph. The result is Order[1..N] }
Var ParentsCount: array[1..MaxN] of integer;
    Used: array[1..MaxN] of boolean;
    I, J, Count: integer;
Begin
  { finding the number of parents for each vertice - ParentsCount[1..N] }
  FillChar(ParentsCount,SizeOf(ParentsCount),0);
  for I:= 1 to N do
    for J:= 1 to N do
      if CanBePut(J,I) then {J can be on I}
        Inc(ParentsCount[J]);
  { apply a topological sorting of the graph to obtain Order[1..N] }
  FillChar(Used,SizeOf(Used),false);
  for Count:= 1 to N do
    for I:= 1 to N do
      if not Used[I] then
        if ParentsCount[I] = 0 then
          begin { when a vertice without father is found }
            Order[Count]:=I;
            Used[I]:=true; {remove the vertice I with all its edges}
            for J:= 1 to N do
              if CanBePut(J,I) then
                Dec(ParentsCount[J]);
            Break;
          end;
End;


Procedure FindMaxCylindersHeight;
Var MaxHeight: array[1..MaxN] of integer;
    Cur, Prev, Max: integer;
    OutF: Text;
Begin
  { Calculating the maximal height - MaxHeight[V] finishing in vertice V }
  for Cur:= 1 to N do
    begin
      Max:=C[Order[Cur]].h;
      for Prev:= Cur-1 downto 1 do
        if CanBePut(Order[Cur],Order[Prev]) then
          if MaxHeight[Prev] + C[Order[Cur]].h > Max then
            Max:= MaxHeight[Prev] + C[Order[Cur]].h;
      MaxHeight[Cur]:=Max;
    end;
  { Find and print the height of heightest tower }
  Max:=0;
  for Cur:= 1 to N do
    if MaxHeight[Cur] > Max then Max:=MaxHeight[Cur];
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,Max);
  Close(OutF);
End;


BEGIN
  ReadData;
  TopSort;
  FindMaxCylindersHeight;
END.
