/* Input is: N M; l1..ln; L1..Lm
  5 2
  4
  10
  2
  5
  3
  11
  13
				   
				  --------

        ,   N (N < 100)
            
    M  (1 < M < 10),    
 1  ,        .   
   l1, l2, ... , ln   -   
     1  100,           ,
    .    , 
            
 L1, L2, ... Lm     .
              .
          ,
       ,    
      .

 :

       ,      
         , 
 ,   (  )   .

        ?      
        .   
       (    
 ,           ).
         
      .      
       .    
       (      
  used,     ).      
        .   
          .
            
 .    -    
     1-  -.       
   ,       
   ,           ,
       .
       ,      
   (     N  M).   
      .    
      .     
          ,  
       .
   ,     ,  
   0.1 .         
     .    
        
      .

Petko Minkov
*/
#include <fstream.h>
#include <time.h>
#include <stdlib.h>
#include <process.h>

#define MAXN 100
#define MAXM 10

int blen[MAXN], plen[MAXN];
int n, m, runs;
int used[MAXN];
int pristan[MAXN];

void readdata()
{
   int      i;
   ifstream fin("boat.cpp");
   fin.ignore(80, '\n');

   fin >> n >> m;
   for(i=1;i<=n;i++)
     fin >> blen[i];

   for(i=1;i<=m;i++)
     fin >> plen[i];

   fin.close();
}

void writesol()
{
   int i, j, count;

   for(i=1;i<=m;i++)
   {
      count = 0;
      for(j=1;j<=n;j++)
	if(pristan[j] == i)
	  count++;

      cout << count << endl;
      for(j=1;j<=n;j++)
	if(pristan[j] == i)
	  cout << blen[j] << " ";
      cout << endl;
   }

   exit(0); // halt
}

void order(int npos, int mpos, int curlen)
{
   int i;

   /*       
           */
   if(clock() / CLK_TCK > runs * 0.1)
     return;

   if(mpos == m + 1)
     writesol();

   for(i=npos;i<=n;i++)
     if(!used[i] && curlen + blen[i] <= plen[mpos])
     {
	used[i] = 1;
	pristan[i] = mpos;
	/*       ? */
	if(curlen + blen[i] == plen[mpos])
	  order(1, mpos + 1, 0);
	else
	  order(npos + 1, mpos, curlen + blen[i]);
	used[i] = 0;
     }
}

void swap(int &a, int &b)
{
   int tmp = a; a = b; b = tmp;
}

void sort_ascending()
{
   int tmp, i, j;

   for(i=1;i<=n;i++)
     for(j=i+1;j<=n;j++)
       if(blen[i] > blen[j])
	 swap(blen[i], blen[j]);
}

void sort_descending()
{
   int tmp, i, j;

   for(i=1;i<=n;i++)
     for(j=i+1;j<=n;j++)
       if(blen[i] < blen[j])
	 swap(blen[i], blen[j]);
}

void randperm()
{
   int i;

   for(i=1;i<=n;i++)
     swap(blen[i], blen[random(n)+1]);
}

void solve()
{
   // process original sequence
   runs++;
   order(1, 1, 0);

   // process sorted sequences
   sort_ascending();
   runs++;
   order(1, 1, 0);

   sort_descending();
   runs++;
   order(1, 1, 0);

   // generate random permutations
   while(1)
   {
      randperm();
      runs++;
      order(1, 1, 0);
   }
}

void main()
{
   readdata();
   randomize();
   solve();
}