/* Input data is: N A B
 20 15 15


			       
			      -------

          N  (1<=N<=20).    
         (0<=<=15, 0<=B<=15). , 
   ,    .       
   .          
          .     
   .          
  .           
       a   .

 :

          
          
       .    
              
    B    N    :

		  A   B
      F(N,A,B) =       F(N-1,A-i,B-j)
		 i=0 j=0
      F(0,A,B) = 1

     .       
       N (i ),    
       (j ).    
         .  
     F    .
           
   .       
        . 
           
      ,      .
       O(N*A*B),
         ,   
   N, A  B,       
 N*A*B.       ,  
     .
       ,    int,    ""
   .        
     .        
 -  - .    - 
     ,         
  .       ++,  
        ,  e 
              
 int .

Petko Minkov
*/
#include <fstream.h>
#include <string.h>

#define MAXD 25
#define MAXN 21
#define MAXAB 16
#define max(a, b) ((a) > (b) ? (a) : (b))

class large {
  public:
    int  dc; //   
    char d[MAXD]; //  

    large();
    large(int);
    large operator +(large);
    void writeln();
};

large::large()
{
   memset(d, 0, sizeof(d));
   dc = 0;
}

large::large(int val)
{
   memset(d, 0, sizeof(d));
   dc = 0;
   while(val)
   {
      d[++dc] = val % 10;
      val /= 10;
   }
}

large large::operator +(large b)
{
   int   i, carry, v;
   large res;

   carry = 0;
   for(i=1;i<=max(b.dc, dc);i++)
   {
      v = d[i] + b.d[i] + carry;
      res.d[++res.dc] = v % 10;
      carry = v / 10;
   }

   if(carry)
     res.d[++res.dc] = carry;

   return res;
}

void large::writeln()
{
   int i;

   for(i=dc;i>=1;i--)
     cout << int(d[i]);
   cout << endl;
}

/* program data */

int   n, a, b;
large t[MAXN][MAXAB][MAXAB];

void readdata()
{
   ifstream fin("boxes.cpp");
   fin.ignore(80, '\n');

   fin >> n >> a >> b;
   fin.close();
}

large calc(int n, int a, int b)
{
   int   i, j;
   large sum;

   if(n == 0)
     return 1;

   if(t[n][a][b].dc)
     return t[n][a][b];

   for(i=0;i<=a;i++)
     for(j=0;j<=b;j++)
       sum = sum + calc(n - 1, a - i, b - j);

   t[n][a][b] = sum;
   return sum;
}

void main()
{
   readdata();
   calc(n, a, b).writeln();
}