/*
  
    , , , 2001.

 

         .
     128  .     p  - k,
   E    c.

 c = E(p, k)

        D, , :

 D(E(p, k), k) = p, E(D(c, k), k) = c.

        - 1  2 ,
 :

 c2 = E(E(p, k1), k2)
 
       s.  - 4*s  
    .  128-4*s -  
 .
 
      ,     s,    
 k1  2.         .

 

      p  c2.    
     .

  

  1
  00112233445566778899AABBCCDDEEFF
  6323B4A5BC16C479ED6D94F5B58FF0C2

 

   -         
  .    ,      . 
       .
              
           p.
        16^s.      
       c2.     16^s.

       :
   Ci = E(p, ki)

       :
   Dj = D(s, kj)

       :
   Ci = Dj,   i = 1..16^s  j = 1..16^s.

        B,   :
   B = E(p, k1)  E(B, k2) = c2.

           
   ,   .   .
            
  .   ,      
            .
          .
         
  ,          
  P633        .
         
 olympiads.win.tue.nl/ioi.

  
*/
#include <fstream.h>
#include <stdlib.h>
#include "aeslibc.h"

#define IN_FILE         "double.in"
#define M_SIZE          1048577

struct Pair {
  Block key, c;
};

Pair pr[M_SIZE];
bool flag;
HexStr hs_s, hs_t, hs_key;
Block s, t;
int n, size;

const char hexsymb[16] =
  {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
   'A', 'B', 'C', 'D', 'E', 'F'};

int cmppair(const void* ac, const void *bc)
{
  int i;
  Pair a = *(Pair*) ac;
  Pair b = *(Pair*) bc;
  
  for(i = 0; i < BLOCKLEN; i++)
    if(a.c[i] < b.c[i])
     return -1;
    else
      if(a.c[i] > b.c[i])
        return 1;
}

int cmpblock(Block& a, Block& b)
{
  int i;

  for(i = 0; i < BLOCKLEN; i++)
    if(a[i] < b[i])
      return -1;
    else
      if(a[i] > b[i])
        return 1;
  return 0;
}

void readinput()
{
  ifstream fin(IN_FILE);
  fin >> n;
  fin >> hs_s;
  fin >> hs_t;

  hexstr2block(hs_s, s);
  hexstr2block(hs_t, t);
  fin.close();
}

int binsearch(Block& dec)
{
  int l, r, res, m;

  l = 1; r = size;

  do
  {
    m = (l + r) / 2;
    res = cmpblock(pr[m].c, dec);
    if(res == -1) l = m + 1;
    else if(res == 1) r = m - 1;
    else return m;
  }
  while(l <= r);
  return -1;
}

void checkkey()
{
  Block key, enc, dec;
  int i, pos;
  
  hexstr2block(hs_key, key);
  if(!flag)
  {
    encrypt(s, key, enc);
  
    size++;
    for(i = 0; i < BLOCKLEN; i++)
      pr[size].key[i] = key[i], pr[size].c[i] = enc[i];
  }
  else
  {
    decrypt(t, key, dec);
    if((pos = binsearch(dec)) != -1)
    {
      block2hexstr(pr[pos].key, hs_key);
      cout << hs_key << endl;
      block2hexstr(key, hs_key);
      cout << hs_key << endl;
      exit(0);
    }
  }
}

void generate(int ind)
{
  int i;

  if(ind == n) { checkkey(); return; }

  for(i = 0; i < 16; i++)
  {
    hs_key[ind] = hexsymb[i];
    generate(ind + 1);
  }
}

void main()
{
  readinput();
  generate(0);
  qsort((void*)(pr + 1), size, sizeof(Pair), cmppair);
  flag = true;
  generate(0);
}
