{ This is the input data:  N;  ghosts' N coordinates;  ghostbusters' N coords
  4
 6 7   11 6   8 3   4 5
 1 3   14 7   4 9   11 1

                             
                           ---------------

           N     N .  -
       ,       , 
          .    
     -,       
         .        -
  .      N        N
      ,        .

    :        1  N, ,  
    .       "  ".
          ,    , 
     L    D       
 ,           .  
  L     D,           -
   .          -
 -,         , -
         .    
 :
       *        O             *         O             *         O
           *                      *                      *
   O *          *        O *           *         O *         *
           O                      O                      O
       O                      O                       O
                         1                2

       *        O             *         O
          *                     *     
   O*        *        O*          *
          O                     O
       O                      O
       3                4

  4  "O"  4  "*".       -
  -   2   2 ,        .  
     ,     ,      
  . ,         
  ,             
           
   .   0         -
 .       ,    . 
      ,       ,
   ,       .    
     ,       ,  -
    ,     .

}

CONST MaxN = 200;
      InFileName = 'GHOSTS.PAS';

TYPE TPoint = record x,y:integer; end;

VAR N: integer;
    Duh, Lovec: array[1..MaxN] of TPoint;
    Target: array[1..MaxN] of integer;


Procedure ReadData; {   - N,  Duh[1..N], Lovec[1..N]}
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    with Lovec[N] do
      Read(F,x,y);
  for N:= 1 to N do
    with Duh[N] do
      Read(F,x,y);
  Close(F);
End;


Procedure FindTargets; {      }
Var Color, LastColor, i: integer;
    DuhColor, LovecColor: array[1..MaxN] of integer;

  Function Direction(p1,p2,p3:TPoint): integer; {   3 }
  Var D: longint;
  Begin
    D:= p1.X*(p2.Y-p3.Y) + p2.X*(p3.Y-p1.Y) + p3.X*(p1.Y-p2.Y);
    if D < 0 then Direction:=-1
    else if D > 0 then Direction:= 1
    else Direction:=0;
  End;

  Function CanAttack(L,D:integer): boolean;
  {   L-D      }
  Var i, LovciLeft, DuhoveLeft, LovciRight, DuhoveRight: integer;
  Begin
    CanAttack:=false;
    LovciLeft:=0; DuhoveLeft:=0; LovciRight:=0; DuhoveRight:=0;
    for i:= 1 to N do
      if (i <> L) and (LovecColor[i] = Color) then
        case Direction(Lovec[L], Duh[D], Lovec[i]) of
	  -1: Inc(LovciLeft);
           1: Inc(LovciRight);
	   0: Exit;
        end;
    for i:= 1 to N do
      if (i <> D) and (DuhColor[i] = Color) then
        case Direction(Lovec[L], Duh[D], Duh[i]) of
	  -1: Inc(DuhoveLeft);
           1: Inc(DuhoveRight);
	   0: Exit;
        end;
    CanAttack:= (LovciLeft=DuhoveLeft) or (DuhoveRight=LovciRight);
  End;

  Procedure MarkThePoints(L,D:integer); {    }
  Var i: integer; {  L-D      }
  Begin
    for i:= 1 to N do
      if (i <> L) and (LovecColor[i] = Color) then
        if Direction(Lovec[L], Duh[D], Lovec[i]) < 0 then
          LovecColor[i]:=LastColor+1
        else LovecColor[i]:=LastColor+2;
    for i:= 1 to N do
      if (i <> D) and (DuhColor[i] = Color) then
        if Direction(Lovec[L], Duh[D], Duh[i]) < 0 then
	  DuhColor[i]:=LastColor+1
	 else DuhColor[i]:=LastColor+2;
  End;

  Procedure FindTargetsForCurrentColor; {   -}
  Var L,D: integer; {         }
  Begin
    for L:= 1 to N do
      for D:= 1 to N do
        if (LovecColor[L] = Color) and (DuhColor[D] = Color) then
          if CanAttack(L,D) then
            begin {  Lovec     Duh}
              MarkThePoints(L,D);
              Inc(LastColor,2);
              Target[L]:=D;
              Exit;
            end;
  End;

Begin
  LastColor:=1;
  for i:= 1 to N do DuhColor[i]:=LastColor;
  for i:= 1 to N do LovecColor[i]:=LastColor;
  for i:= 1 to N do Target[i]:=LastColor;
  Color:=1;
  repeat
    FindTargetsForCurrentColor;
    Inc(Color);
  until Color > LastColor;
End;


Procedure PrintResults;
Var L: integer;
Begin
  WriteLn;
  for L:= 1 to N do
    if Target[L] <> 0 then
      WriteLn(L,' - ',Target[L]);
End;


BEGIN
  ReadData;
  FindTargets;
  PrintResults;
END.