/*
 2. 

         
,      .     
  ,         
 "  ",   .   ,  
          " ".
      .

 "  "   .      
 ,   ,         
   ,    ,     
  -   -   .   
 ,    -     .

      ,      .
    1  N.       
   .     ,   
      "".    
   ,      ,  
.     :   ,
         K ,  
     : 

    X  ,      Y,
     S = q*K+R  (  X-Y).  Y
    AR,    ,      AR -  
    .       
      .     
            ,  
    ,    .

  LIGHTS.EXE,        
        .

      .       3
  :    N (2 <= N <=  200), 
  M  K (1 <= K <= 10).  N   .
         - ""
   .   ,    
       -1.    
 M ,  .      3 
 -    ,    ,  
   .       
,         ,
    .

       .    
        ,   
    "No route",     .

:

:

8 9 2
10
-1
2 3 -1
5
1 3 -1
4 5 -1
5
1 -1
2 4 -1
4
2 3 -1
6 -1
7
2 -1
6 -1
2
4 5 -1
-1
100
8 -1
-1
100
7 -1
-1
1 2 11
1 3 15
2 3 6
2 4 7
2 5 30
3 4 12
4 6 34
5 6 2
7 8 2000
1 6
1 7
 

:
 
50
No route



   2: 
  

     -       ,
          .  
      -      
       .       
,       ,     
       ,         
             .  
            -
   . -     , 
   ,        
,  -     K   .

              -
,    -    ,    r  
 K,    .

        N*K ,       
 K  ,       ,     
       K.       
 a  b,     K  ,       a  b
,        ,    
  .

            ,
    - ,   ,    
      .      ,   -
     .
*/



/*
NAME: Ivan Anev
PROG: lights
LANG: C++
*/

#include <cstring>
#include <cstdio>

using namespace std;

const int maxn = 200;
const int maxk = 10;
const int maxd = 1000000000;

class Lights {
private:
	struct Edge {
		int v, w;
		Edge *next;
	};
	struct Vex {
		int slow;
		Edge *edges;
	};
private:
	int n, m, k;
	Vex vs[maxn];
	int s[maxn][maxk][maxn];
	int d[maxn][maxn];
	int x[maxn*maxk], v[maxn*maxk];
	int computed[maxn];
private:
	void add_edge(int a, int b, int w) {
		Edge *e;

		e = new Edge;
		e->v = b;
		e->w = w;
		e->next = vs[a].edges;
		vs[a].edges = e;
	}
	void dijkstra(int src) {
		int i, j, nn, t, cv, cr, nv, nr, nt, ev;
		Edge *e;

		nn = n * k;
		for (i = 0; i < nn; i++) {
			v[i] = 0;
			x[i] = maxd;
		}
		x[src*k] = 0;

		for (i = 0; i < nn; i++) {
			t = -1;
			for (j = 0; j < nn; j++)
				if (v[j] == 0 && (t == -1 || x[j] < x[t]))
					t = j;
			v[t] = 1;
			cv = t / k;
			cr = t % k;
			nr = (cr + 1) % k;
			for (e = vs[cv].edges; e; e = e->next) {
				nv = e->v;
				nt = x[t] + e->w;
				if (s[nv][nr][cv] == 0)
					nt += vs[nv].slow;
				ev = nv * k + nr;
				if (x[ev] > nt)
					x[ev] = nt;
			}
		}

		for (i = 0; i < n; i++) {
			t = maxd;
			for (j = 0; j < k; j++)
				if (x[i*k+j] < t)
					t = x[i*k+j];
			d[src][i] = t;
		}
	}
public:
	void solve() {
		int i, j, t, a, b, w;

		scanf("%d%d%d", &n, &m, &k);
		memset(s, 0, sizeof(s));
		for (i = 0; i < n; i++) {
			scanf("%d", &vs[i].slow);
			for (j = 0; j < k; j++)
				while (1) {
					scanf("%d", &t);
					if (t == -1)
						break;
					s[i][j][t-1] = 1;
				}
		}

		for (i = 0; i < m; i++) {
			scanf("%d%d%d", &a, &b, &w);
			add_edge(a - 1, b - 1, w);
			add_edge(b - 1, a - 1, w);
		}

		memset(computed, 0, sizeof(computed));
		while (scanf("%d%d", &a, &b) == 2) {
			a--;
			b--;

			if (computed[a] == 0) {
				dijkstra(a);
				computed[a] = 1;
			}

			if (d[a][b] < maxd)
				printf("%d\n", d[a][b]);
			else
				printf("No route\n");
		}
	}
};

Lights lights;

int main() {
	lights.solve();

	return 0;
}

