/*
 3-      '2000
  2: 
 
 :      N <= 175   M <= 10000 .    W[i]
        R[i][j]      .   
   4 ,   /       .
  /          .

 :                                : 18
   12 16
   7
   9
   5
   1
   1
   2
   4
   2
   5
   3
   8
   8
   1 2 17
   1 4 4
   1 9 3
   1 12 9
   2 6 20
   2 4 1
   3 6 4
   3 7 9
   4 6 1
   4 7 11
   4 8 3
   5 9 8
   7 8 5
   8 12 2
   9 11 6
   10 12 5

 :  R[i][i]   .       -
 : R[i][i] = W[i].      (Floyd)  -
   /   :
       I  J   IJ,  IJ = 
      J :
         I  K :
        IJ + JK < IK,  IK = IJ + JK
   ,    .     ,..
      .      
  C,      edge[i][j],      -
 ,       i  j, -  .
         , 
    -      .     
    ,     ( N  ),   ,
   MAX_INT.        -
         .
                
 .          :  ..
 R[i][j] = R[j][i] ,           
          -     
 ,        (    
   )    -.
                                                                 
*/
#include <stdio.h>

#define MAX_N 175
#define MAX_M 100000

unsigned int n = 12, m = 16;
int edge[MAX_N][MAX_N] =
{{ 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1 },
 { 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0 },
 { 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0 },
 { 1, 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0 },
 { 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0 },
 { 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0 },
 { 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0 },
 { 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1 },
 { 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0 },
 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1 },
 { 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0 },
 { 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1 }};
unsigned int dist[MAX_N][MAX_N] =
{{  7, 17,  0,  4,  0,  0,  0,  0,  3,  0,  0,  9 },
 { 17,  9,  0,  1,  0, 20,  0,  0,  0,  0,  0,  0 },
 {  0,  0,  5,  0,  0,  4,  9,  0,  0,  0,  0,  0 },
 {  4,  1,  0,  1,  0,  1, 11,  3,  0,  0,  0,  0 },
 {  0,  0,  0,  0,  1,  0,  0,  0,  8,  0,  0,  0 },
 {  0, 20,  4,  1,  0,  2,  0,  0,  0,  0,  0,  0 },
 {  0,  0,  9, 11,  0,  0,  4,  5,  0,  0,  0,  0 },
 {  0,  0,  0,  3,  0,  0,  5,  2,  0,  0,  0,  2 },
 {  3,  0,  0,  0,  8,  0,  0,  0,  5,  0,  6,  0 },
 {  0,  0,  0,  0,  0,  0,  0,  0,  0,  3,  0,  5 },
 {  0,  0,  0,  0,  0,  0,  0,  0,  6,  0,  8,  0 },
 {  9,  0,  0,  0,  0,  0,  0,  2,  0,  5,  0,  8 }};
 
unsigned int min;

int main( void )
{
  int i, j, k, t; // 

// Floyd
  for( j = 0; j < n; j++ )
    for( i = 0; i < n - 1; i++ )
      for( k = i; k < n; k++ )
	if( i != j && i != k && j != k )
	  if( !edge[i][k] || ( t = dist[i][j] + dist[j][j] + dist[j][k] ) < dist[i][k] )
	    dist[k][i] = dist[i][k] = t,
            dege[i][k] = edge[k][i] = 1;

//   4-     
  min = ~0;
  for( i = 0; i < n - 3; i++ )
    for( j = i + 1; j < n - 2 && m < min; j++ )
    {
      m = dist[i][j];
      for( k = j + 1; k < n - 1 && m < min; k++ )
      {
        m += dist[i][k] + dist[j][k];
        for( t = k + 1; t < n && m < min; t++ )
        {
          m += dist[i][t] + dist[j][t] + dist[k][t];
          if( m < min )
            min = m;
          m -= dist[i][t] + dist[j][t] + dist[k][t];
        }
        m -= dist[i][k] + dist[j][k];
      }
    }
    
  printf( "%d", min );

  return 0;
}
