/*
 '2000
  C:  
 
 :             -
   .
  :          -  .
       .    ,  "
 "  " "  -      ,  
      ,  .
      ,       -
 ,  ,         .   - -
     ,      -     ,
      N-    (N    -  500)
   ,        .  
           ( ,
  ),        .  -
     ,    1  N,     
      -      
 [-10000,10000],        . -
       M   ,   -
      (M     1500).     
    ,           
       -  ,     20.   ,
     ,        .
                 -
 ,     ,      -
 .    -   SNOW.EXE,    -
     ,         
   ,        .
                SNOW.INP,     
     N  M,     .   
 N        ,    
     ,    .   -
  M         ,   -
       ,     .
               SNOW.OUT
          -
  .
 
 SNOW.INP		SNOW.OUT
 6 9			13
 0 6
 0 2
 -2 -1
 -4 -3
 3 -2
 5 -3
 1 2 10
 1 4 11
 1 6 13
 2 3 6
 2 5 9
 3 4 4
 3 5 2
 4 6 12
 5 6 1

 :      ,        2 -
  :          -
     -      -  ( 
    -)    (    -
  )   .
            ,   -
 ,       .  
 :
      X =   - x 
       X    
       :
          Y <> X
         I := A[0]  [n]  I <> X  I <> Y :
          A d( X, Y, I ) < 0,  Y := I
         Y   ,  
         Y    
        X := Y
  A[i]     ,  X, Y, I    (-
    .)
             .     
    (Dijkstra)          
  .  ,           
   .    , ,     
            (
         .)     
     ,    0     
  . ,       .
          ,      -
     .     "" , -
           -   -
 .
 ..         -
 ,     1   ,   2  ..
                                                                 
*/
#include <stdio.h>

#define MAX_N 500

#define INFINITY ~0

#define NOT_REACHED 0
#define REACHED     1
#define PASSED      2

#define IN_ROUND REACHED

#define d(a,b,c) (a.x*b.y+b.x*c.y+c.x*a.y-a.x*c.y-c.x*b.y-b.x*a.y)
#define cmp( a, b ) (a.x == b.x && a.y == b.y ? 1 : 0)

typedef struct { int x, y; } vertex;

unsigned n = 6, m = 9;
vertex a[MAX_N] = {{ 0, 6 }, { 0, 2 }, { -2, -1 }, { -4, -3 }, { 3, -2 }, { 5, -3 }};
unsigned link[MAX_N][MAX_N] =
{{  0, 10, 0, 11, 0, 13 },
 { 10,  0, 6,  0, 9,  0 },
 {  0,  6, 0,  4, 2,  0 },
 { 11,  0, 4,  0, 0, 12 },
 {  0,  9, 2,  0, 0,  1 },
 { 13,  0, 0, 12, 1,  0 }};

unsigned state[MAX_N];
unsigned dist[MAX_N];

void warp( void )
{
  vertex x;
  int i, j;

  for( i = 1, x = a[0]; i < n; i++ )
    if( a[i].x > x.x ) j = i;
  x = a[j], state[j] = IN_ROUND;

  for(;;)
  {
    if( !cmp( x, a[0] ) )
      j = 0;
    else
      j = 1;
    for( i = 0; i < n; i++ )
      if( !cmp( a[i], a[j] ) && !cmp( a[i], x ) && d( x, a[j], a[i] ) < 0 )
        j = i;
    if( state[j] == IN_ROUND ) break;
    state[j] = IN_ROUND, x = a[j];
  }

  return;
}

int done( void )
{
  unsigned i;
  
  for( i = 0; i < n; i++ )
    if( state[i] != PASSED ) return 0;
  return 1;
}

void dijkstra( void )
{
  unsigned i, min;
  
  dist[n] = INFINITY;
  do
  {
    for( i = 0, min = n; i < n; i++ )
      if( state[i] == REACHED && dist[i] < dist[min] )
        min = i;
    state[min] = PASSED;
    for( i = 0; i < n; i++ )
      if( link[min][i] && link[min][i] + dist[min] < dist[i] )
        dist[i] = link[min][i] + dist[min], state[i] = REACHED;
  }
  while( !done() );

  return;
}

int main( void )
{
  int i, k, l;

  warp();
  for( i = 0; i < n; dist[i] = state[i] == IN_ROUND ? 0 : INFINITY, i++ );
  dijkstra();

  for( i = k = 0; i < n; k += dist[i++] );
  printf( "%d", k );
  
  return 0;
}
